' Factura-Software Scriptdatei 
' Funktion: 	Hilfsdatei mit Kernfunktion zur Anlage einer detaillierten Sammelrechnung
' Ansicht:  	Firmen
' Script:	Firmen_08_Sammelrechnung_Detailliert.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------



<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->



Sub Sammelrechnung()




'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "004"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 004 
' - Modul Adressen integriert
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Stored Procedure kontrolliert ausfhren (Sicherheitsmechanismen)
' Beleg_Typ korrigiert
'--------------------------------------------------------------------------------------------------------------
' Version 003 
' - Prfung, ob Datensatz gesperrt
' Beleg_Typ korrigiert
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "174"
sErrorSkript    = "008"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'-----1. Auslesen der Basisinformationen : Firma, Person  -----

'Auslesen der Benutzerinformationen
Dim sErfuser, i
sErfuser = Crm.CurrentProject.CurrentUser


'Auslesen der FirmenRecordid
Dim   sFirmenRecordid
sFirmenRecordid= Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ID")

 Dim bLieferscheinSelektion
        
        bLieferscheinSelektion = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'SammelrechnungLieferscheinSelektion')","Result", "Der globale Parameter SammelrechnungLieferscheinSelektion wurde nicht gefunden. Es wird die Einstellung ""ja"" verwendet") 
  
       If bLieferscheinSelektion = "" Then
         bLieferscheinSelektion = "Ja"
       End If
       
       If bLieferscheinSelektion = "Ja" Then
         bLieferscheinSelektion = "Ja" 
       Else
         bLieferscheinSelektion = "Nein"
       End If
       

'----- 2. Lieferscheine anzeigen die Berechnet werden sollen -----
Dim sFilterSQL

sFilterSQL =   " select b.Recordid " _
		& "from " _
		&"  Factura_Belege b, " _
		&" Factura_Beleg_Typen t " _
		&" Where b.Beleg_Typen_Recordid = t.Recordid " _
		&" and t.ID = 5 " _
		&"AND " _
		&"( " _
		&"  b.GroupID is null  " _
		&" or " _
		&"  ( " _
		&"   SELECT " _
		&"    COUNT(dbo.Factura_Beleg_Typen.ID) AS anz " _
		&"   FROM " _
		&"    dbo.Factura_Belege Factura_Belege1 " _
		&"  INNER JOIN dbo.Factura_Belege ON (dbo.Factura_Belege.Vorgangnr = Factura_Belege1.Vorgangnr) " _
		&"  INNER JOIN dbo.Factura_Beleg_Typen ON (dbo.Factura_Belege.Beleg_Typen_Recordid = dbo.Factura_Beleg_Typen.Recordid) " _
		&" WHERE " _
		&"  Factura_Belege1.GroupID IS NOT NULL AND " _
		&"  b.GroupID = Factura_Belege1.GroupID AND " _
		&"  Factura_Beleg_Typen.ID = 3  " _
		&"  ) = 0 " _
		&")" _
		&"AND " _
		&" b.Firmen_Recordid = 0x" & sFirmenRecordid _
		&" AND " _
		&" b.Sammelrechnung_Recordid is NULL"
		
		
Dim oBelegeRecordSet, oBelegeViewConfig,oBelegeRecord
Dim oRecordset, bFilter, oCosmoExt, oSel, sRecordIDs

Set  oBelegeViewConfig = cRM.CurrentProject.ViewConfigs.ItemByName(CStr("FakturaBelege"))
Set  oBelegeRecordSet = oBelegeViewConfig.CreateRecordSet

if oBelegeRecordSet.SetFilterDirectSQL(sFilterSQL) Then ' Filter sFilterSQL ok
  If oBelegeRecordSet.RecCount = 0 Then
      ShowMessage("Es wurden keine Lieferscheine fr eine Sammelrechnung gefunden." &vblf & vblf &"Die Funktion wird beendet.")
       Wscript.Quit
  Else
    	'ShowMessage("NEXT")
    
    If bLieferscheinSelektion = "Ja" Then ' Lieferscheinselektion
                
    
	  	Set oRecordset = oBelegeRecordSet
	  	
	  	' fehlende DLL abfangen
	  	On Error Resume Next
	  	Set objExt = CreateObject("cosmolinkCRMExt.application")
	  	If ((objExt Is Nothing) OR (Err.Number <> 0)) Then
	  	 	Msgbox("Diese Funktion seht nach Freischaltung von cosmolink faktura zur Verfgung. Der Vorgang wird beendet.")
	   		WScript.Quit
	  	End If
		On Error GoTo 0
	  	' / fehlende DLL abfangen
	  	
	  	
	  	'Set oCosmoExt = CreateObject("cosmolinkCRMExt.application")
	  	'ShowMessage oCosmoExt.Version
	  	Set oSel		= oCosmoExt.RecordSetSelection("Bitte whlen Sie die Lieferscheine fr die Sammelrechnung aus.","selFactura_Sammelrechnung1")
	  	oSel.SetReturnField "Vorgangnr", false
	  	'oSel.SetField "Recordid", "Datensatz-ID" , 150, "C"
		oSel.SetField "Vorgangnr", "Vorgang" , 60, "C"
	  	oSel.SetField "Belegnr", "LS Nr" , 60, "CL"
	  	oSel.SetField "Belegdat", "Datum" , 60, "C"
		oSel.SetField "Recordid.v_FakturaBelege_Summe.Belege_Recordid.Netto_Beleg_Total", "Gesamt Netto" , 100, "CR" '"1,2,3,...9"
		oSel.SetField "Waehrung.FakturaWhrungen.ID.Kurzname", "Whrung" , 60, "CR" 
		oSel.SetField "Betreff", "Betreff" , 150, "C"
		oSel.SetField "Information", "Information" , 150, "C"
	 
	 	Dim sDelemiter
	 
	 	sDelemiter = ","
	  
		if oSel.Show(oRecordset, ActiveWindow.Handle) Then ' Datensatz hinzufgen
	    		'ShowMessage(oSel.SelectedString(";"))
	    		sRecordIDs = oSel.SelectedString(sDelemiter)
	    		'ShowMessage (sRecordIDs)
	    		'copytoclipboard (sRecordIDs)
	    		if (Trim(sRecordIDs) = "") or (sRecordIDs = " ") Then 'Keine Auswahl
	        		ShowMessage("Keine Lieferscheine ausgewhlt" &vblf &vblf & "Das Skript wird beendet...")
				Set oRecordSet = Nothing
				Set oCosmoExt = Nothing
				Set oSel = Nothing
	        		Wscript.Quit
	    		End If '/Keine Auswahl
		End If ' /Datensatz hinzufgen
  
  	Else  ' Lieferscheinselektion
  

  		' bernehme alle Vorgangsnummern im RecordSet in sRecordIDs
           
           Do
     		Set oBelegeRecord = oBelegeRecordSet.CurrentRecordSynchronized
      
              sRecordIDs = sRecordIDs & oBelegeRecord.GetContentsByName("Vorgangnr") & ","
             'showmessage(sRecordIDs)
            Loop Until Not oBelegeRecordSet.MoveNext 
                  
           'Schneide das letzte Komma ab     
           sRecordIDs = Left(sRecordIDs,Len(sRecordIDs)-1)       
  
         End If ' / Lieferscheinselektion

  end If
Else ' / Filter sFilterSQL ok
  	ShowMessage("Bei dem Versuch einen Filter in der Ansicht FakturaBelege auszufhren ist ein Fehler aufgetreten. " &vblf & vblf &"Die Funktion wird beendet.")
       	Wscript.Quit
End If	' /Filter sFilterSQL ok	


' sRecordIDs beinhaltet alle Lieferscheine
' sErfuser, sFirmenRecordid

'----- 3. Auslesen des Belegtyps -----

'Auslesen des Belegtyps Rechnung
Dim sBelegTypRecordid, sViewBelegTyp,sFieldBelegTyp,sFilterBelegTyp,sErrorBelegTyp

sViewBelegTyp   = "FakturaBeleg_Typen"
sFilterBelegTyp = """Factura_Beleg_Typen"".""ID"" = 3"
sFieldBelegTyp  = "Recordid"
sErrorBelegTyp  = "Der Belegtyp konnte nicht ermittelt werden"

sBelegTypRecordid = GetHiddenFieldContentByName(sViewBelegTyp, sFilterBelegTyp,sFieldBelegTyp, sErrorBelegTyp)

'Wenn Recordid leer dann Script beenden
If sBelegTypRecordid = "" Then
  Wscript.Quit
End If


'Auslesen der Belegwhrung
'Whrung auslesen
Dim sWaehrungID, sFilterWaehrung,sViewWaehrung,sFieldWaehrung, sErrorWaehrung


sFilterWaehrung = """Factura_Waehrungen"".""Standard"" = 1"

sViewWaehrung   ="FakturaWhrungen"
sFieldWaehrung  ="ID"
sErrorWaehrung  ="Whrung konnte nicht gefunden werden, Script wird beendet"

sWaehrungID = GetHiddenFieldContentByName(sViewWaehrung, sFilterWaehrung,sFieldWaehrung, sErrorWaehrung)


'---------------------------------------------------------------------------------------------------------------------
'Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------
Dim sAdressID, sLieferAdressID


'Auslesen, ob FakturaAdressen aktiv ist 
Dim sGlobalFilter,sFakturaAdressenAktiv

sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'FakturaAdressenAktiv')"
		
sFakturaAdressenAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")


If sFakturaAdressenAktiv = "Ja" Then 'Adressauswahl

   'Auslesen der Parameter 
   Dim sBelegAdresseAktiv, sLieferAdresseAktiv
   
   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlBelegEmpf')"
   
   sBelegAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")

   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlLieferEmpf')"
   
   sLieferAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
  
  Dim sFilterAdresse,sViewAdresse,sFieldAdresse, sErrorAdresse,oView,oCurrentRecord ',oRecordSet,bFilter
  
  
  'Auslesen Adresse 1: Belegadresse
  If sBelegAdresseAktiv = "Ja" Then
		sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Belegadresse"" = 1"
		sViewAdresse   ="FakturaAdressZuordnung"
		sFieldAdresse  ="AddressID"
		sErrorAdresse  ="Keine Belegadresse vorhanden. Der Beleg wird mit der Hauptadresse der Firma befllt."
		
		'sAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Belegadresse", sErrorAdresse)
		
		
		Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
		
		Set oRecordSet = oView.CreateRecordSet
		
		bFilter = oRecordSet.SetFilter(sFilterAdresse)
		
		If bFilter Then 'Filter OK
			If oRecordSet.Reccount > 1 Then
			
			  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
			  
			  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  If oCurrentRecord Is Nothing Then  
			   sAdressID = "Null"
			  Else 
			    sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			  End If
			  
			    
			ElseIf oRecordSet.MoveFirst Then 
			  
			  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			   sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			
			Else 
			  sAdressID = "Null"
			  showmessage(sErrorAdresse)
			End If
		
		Else 'Filter Ok
		  sAdressID = "Null"
		  showmessage(sErrorAdresse)
		End If ' /Filter OK
		
		
  Else sAdressID = "Null"
  
  End If
  
 'Auslesen Adresse 2: Lieferadresse
 If sLieferAdresseAktiv = "Ja" Then
 
		sViewAdresse   ="FakturaAdressZuordnung"
		sFieldAdresse  ="AddressID"
	    sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Lieferadresse"" = 1"
		sErrorAdresse  ="Keine Lieferadressen vorhanden. Der Beleg wird mit der Lieferadresse der Firma befllt, sofern vorhanden."
		
		'sLieferAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Lieferadresse", sErrorAdresse)
		Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
		
		Set oRecordSet = oView.CreateRecordSet
		
		bFilter = oRecordSet.SetFilter(sFilterAdresse)
		
		If bFilter Then 'Filter OK
			If oRecordSet.Reccount > 1 Then
			
			  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
			  
			  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  If oCurrentRecord Is Nothing Then  
			   sLieferAdressID = "Null"
			  Else 
			    sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			  End If
			  
			    
			ElseIf oRecordSet.MoveFirst Then 
			  
			  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			   sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			
			Else 
			  sLieferAdressID = "Null"
			  showmessage(sErrorAdresse)
			End If
		
		Else 'Filter Ok
		  sLieferAdressID = "Null"
		  showmessage(sErrorAdresse)
		End If ' /Filter OK
		
		
		
		
  Else sLieferAdressID = "Null"
  
  End If 
End If ' / Adressauswahl


' ----- 2. Ausfhren der Stored Procedure -----
   Dim sProcedure, sTrennzeichen,sParameter
   
   sProcedure    = "Fs_Beleg_neu_ohne_Person"
   sTrennzeichen = ";"
   sParameter    = sFirmenRecordid & ";" & sErfuser & ";" &  sBelegTypRecordid  & ";" & sWaehrungID & ";" & sAdressID & ";" & sLieferAdressID
   
 'showmessage(sParameter)
'Wscript.Quit
 'Stored Procedure kontrolliert ausfhren
   Dim bSP 

   bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "002"))
   
   If bSP = False THEN
     'RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
     Wscript.Quit
   End If 
  
'---------------------------------------------------------------------------------------------------------------------
'/ Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------
  










'RECORDSETS LEEREN
Set oBelegeRecordSet = Nothing
Set oBelegeViewConfig =Nothing
Set oRecordset = Nothing

Dim sFilterBeleg

sFilterBeleg = "select Recordid from Factura_Belege where Erf_User = '" &sErfuser &"'  AND (Erf_Dat = (select max(Erf_Dat) from Factura_Belege where Erf_User = '" &sErfuser &"' ))"


'Beleg ffnen
'ActivateOpenViewSetFilterDirectSQL "FakturaBelege",sFilterBeleg

End Sub

Function AnzahlZeichenInString(Zeichen , Kette ) 

Dim i, count 

'count = 1

For i = 1 To Len(Kette)
If Mid(Kette, i, len(Zeichen)) = Zeichen Then
count = count + 1
End If
Next

AnzahlZeichenInString = count + 1
End Function

