' Faktura-Software Scriptdatei 
' Funktion: 	Filter unbezahlte Rechnungen
' Ansicht:  	FakturaBelege
' Script:	FakturaBelege_22_Filter_unbezahlte_Rechnungen.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Dr. Frank Wietzel

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------

Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->




'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "005"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 005
' - Beleg Mahnen ab aus global auslesen und in Skript bercksichtigen
' - Belege die im aktuellen Datum - X sich in einem Mahlauf befinden ausschlieen
' Version 004
' - Einbau der Toleranz-Zeit aus der Factura Software Global (Mahnwesen_Toleranz_Zeit_Tage)
' Version 003
' - Anpassung des Filters
'Version 002
' - Einbau Beleg_Mahnung = 1
'--------------------------------------------------------------------------------------------------------------


Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "022"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------
' Filter 002
'sFilter = "SELECT Factura_Belege.Recordid FROM Factura_Belege, Factura_Beleg_Typen WHERE (Factura_Belege.Beleg_Typen_Recordid = Factura_Beleg_Typen.Recordid) AND  (Factura_Belege.Zahldatum IS NULL) AND  (Factura_Belege.Restbetrag > 0) AND  (Factura_Beleg_Typen.Beleg_Mahnung = 1)"

'Filter 003
'SELECT 
'	Factura_Belege.Recordid 
 '   FROM Factura_Belege 
  '    inner join Factura_Beleg_Typen on Factura_Belege.Beleg_Typen_Recordid = Factura_Beleg_Typen.Recordid
   '   inner join v_Factura_Belege_Summe on Factura_Belege.Vorgangnr = v_Factura_Belege_Summe.Vorgangnr 
   ' where
    '  Factura_Belege.Zahldatum IS NULL AND  v_Factura_Belege_Summe.Beleg_Betrag_offen > 0
    '  and Factura_Beleg_Typen.Beleg_Mahnung = 1

'

' Change Version 004
' Toleranzzeit Herausfinden
Dim sGlobalView, sGlobalField, sGlobalErrorMsg, sGlobalVariable, sGlobalFilter

sGlobalView 		= "FakturaGlobaleEinstellungen"
sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Toleranz_Zeit_Tage')"
sGlobalField		= "Result"
sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <Mahnwesen_Toleranz_Zeit_Tage> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf

sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

If not IstZahl(sGlobalVariable) Then
 sGlobalVariable = 0
End If

Dim iToleranz

iToleranz = sGlobalVariable

'--- Update bei Version 005 Heruausfinden Beleg Mahnen ab
sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMahnenAbSumme')"
sGlobalField		= "Result"
sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <BelegeMahnenAbSumme> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf

sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

Dim iBelegeMahnenAbSumme

iBelegeMahnenAbSumme = CInt(sGlobalVariable)


'--- Update bei Version 005 Mahnwesen_Mahnlaufdat_Minus_N-Tage d.h. Belege die in einem Mahnlauf sind werden nicht mehr im Filter angezeigt
sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Mahnlaufdat_Minus_N-Tage')"
sGlobalField		= "Result"
sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <Mahnwesen_Mahnlaufdat_Minus_N-Tage> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf

sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

Dim iMahnlaufdat_Minus_NTage

iMahnlaufdat_Minus_NTage = CInt(sGlobalVariable)


Dim sFilter


sFilter = "SELECT  ""Factura_Belege"".""Recordid"""_
         & " FROM ""Factura_Belege"" "_
	 & " inner join ""Factura_Beleg_Typen"" on ""Factura_Belege"".""Beleg_Typen_Recordid"" = ""Factura_Beleg_Typen"".""Recordid""" _
	 & " inner join ""v_Factura_Belege_Summe"" on ""Factura_Belege"".""Recordid"" = ""v_Factura_Belege_Summe"".""Belege_Recordid""" _
	 & " where "_
	 & " (Factura_Belege.Zahlziel IS NULL OR Factura_Belege.Zahlziel < (Getdate()-" &iToleranz &")) " _
	 & " AND  ""v_Factura_Belege_Summe"".""Beleg_Betrag_offen"" > " & iBelegeMahnenAbSumme _
	 & " AND ""Factura_Beleg_Typen"".""Beleg_Mahnung"" = 1" _
     & " and Factura_Belege.Recordid not in  " _
  	 & " ( " _
   	 & " Select m.Belege_Recordid  " _
     & " from Factura_Mahnlauf_Belege m , Factura_Mahnlauf ml  " _
   	 & " WHERE " _ 
   	 & " ( " _
   			& " ml.Mahnlauf_Datum >= CONVERT(datetime, GETDATE()-" &iMahnlaufdat_Minus_NTage &", 104)  " _
   		& " and	ml.Mahnlauf_Datum <= CONVERT(datetime, GETDATE(), 104) " _
   	 & " ) " _
   	 & " and ml.Recordid = m.Mahnlauf_Recordid " _
  	& " ) "


'copytoclipboard(sfilter)
SetFilterDirectSQL(sFilter)

