' Faktura-Software Scriptdatei 
' Funktion: 	Neuen Beleg zur Person anlegen Belegyp 2
' Ansicht:  	Kontakte
' Script:	Kontakte_03_BelegNeu_Typ_2.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->


'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "004"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 004
' - Erweiterung um Modul "FakturaAdressen"
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - Wenn AktiveAdr (Aktive Adresse) P ist, wird der Beleg fr eine Privatperson erstellt.
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Stored Procedure kontrolliert ausfhren (Sicherheitsmechanismen)
'--------------------------------------------------------------------------------------------------------------
' Version 003 
' - Prfung, ob Datensatz gesperrt
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "175"
sErrorSkript    = "003"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

Dim sAdressID, sLieferAdressID
Dim sTrialDat, sBelegAdresseAktiv, sLieferAdresseAktiv

'----- Prfung, ob Datensatz gesperrt
Dim sGesperrt,sAktiveAdr,sFirmaGesperrt

sGesperrt = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Blocked")

sAktiveAdr = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ActiveAddress")


if ((sGesperrt="true") or (sGesperrt="wahr")) and sAktiveAdr = "P" then
  showmessage("Privatdatensatz fr Belege gesperrt. Es wird kein Beleg angelegt.")
  wscript.quit
end if


if sAktiveAdr="F" then
  sFirmaGesperrt = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("CompanyID.Firmen.ID.Blocked")
  
End if

if sFirmaGesperrt = "true" then
  showmessage("Firmendatensatz fr Belege gesperrt. Es wird kein Beleg angelegt.")
  Wscript.Quit
End if

'-----1. Auslesen der Basisinformationen : Firma, Person  -----



'Auslesen der Benutzerinformationen
Dim sErfuser
sErfuser = Crm.CurrentProject.CurrentUser

'Auslesen: Privatadresse oder Firmenadresse
Dim bPrivatadresse
Dim sFirmenRecordid

bPrivatadresse = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ActiveAddress")
'showmessage(bPrivatadresse)

'Auslesen der FirmenRecordid
If bPrivatadresse  = "F" Then
  sFirmenRecordid = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("CompanyID")
  ' Wenn Firma leer, dann Abbruch und Meldung
  If sFirmenRecordid = "" Then
    showmessage("Es wurde keine Firma zur Person gefunden. Bitte prfen Sie das Feld ""Aktive Adresse"" auf der Registerkarte ""Adresse"" und setzen Sie dieses entsprechend auf" & vbLf & vbCr & vbLf & vbCr & "(F) fr Firmenadresse oder" & vbLf & vbCr & "(P) fr Privatadresse" &vbLf & vbCr & vbLf & vbCr &"Der Vorgang wurde beendet.")
    WScript.Quit 
  End If
ElseIf bPrivatadresse = "P" Then
  sFirmenRecordid = "00000000000000000000000000000000" 
Else
  Showmessage("Bitte prfen Sie das Feld ""Aktive Adresse"" auf der Registerkarte ""Adresse"" und setzen Sie dieses entsprechend auf" & vbLf & vbCr & vbLf & vbCr & "(F) fr Firmenadresse oder" & vbLf & vbCr & "(P) fr Privatadresse" &vbLf & vbCr & vbLf & vbCr &"Der Vorgang wurde beendet.")
  WScript.Quit
End If




'Abfrage zu Person
Dim sPersonRecordid
sPersonRecordid = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ID")

If sPersonRecordid = "" Then
  RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Die Person konnte nicht bestimmt werden. " & vbLF & "Das Script wird nicht fortgesetzt")
  WScript.Quit
End If 

'----- 2. Auslesen des Belegtyps -----

'Auslesen des Belegtyps
Dim sBelegTypRecordid, sViewBelegTyp,sFieldBelegTyp,sFilterBelegTyp,sErrorBelegTyp

sViewBelegTyp   = "FakturaBeleg_Typen"
sFilterBelegTyp = """Factura_Beleg_Typen"".""ID"" = 2"
sFieldBelegTyp  = "Recordid"
sErrorBelegTyp  = "Der Belegtyp konnte nicht ermittelt werden"

sBelegTypRecordid = GetHiddenFieldContentByName(sViewBelegTyp, sFilterBelegTyp,sFieldBelegTyp, sErrorBelegTyp)

'Wenn Recordid leer dann Script beenden
If sBelegTypRecordid = "" Then
  Wscript.Quit
End If


'Auslesen der Belegwhrung
'Whrung auslesen
Dim sWaehrungID, sFilterWaehrung,sViewWaehrung,sFieldWaehrung, sErrorWaehrung


sFilterWaehrung = """Factura_Waehrungen"".""Standard"" = 1"

sViewWaehrung   ="FakturaWhrungen"
sFieldWaehrung  ="ID"
sErrorWaehrung  ="Whrung konnte nicht gefunden werden, Script wird beendet"

sWaehrungID = GetHiddenFieldContentByName(sViewWaehrung, sFilterWaehrung,sFieldWaehrung, sErrorWaehrung)


		'---------------------------------------------------------------------------------------------------------------------
		'Modul Faktura_Adressen 
		'---------------------------------------------------------------------------------------------------------------------
		' Dim sAdressID, sLieferAdressID wurde oben deklariert
		
		
		'Auslesen, ob FakturaAdressen aktiv ist 
		Dim sGlobalFilter,sFakturaAdressenAktiv
		
		sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'FS-Modul03')"
				
		sFakturaAdressenAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
		'ShowMessage(sFakturaAdressenAktiv)
		sFakturaAdressenAktiv = SplitStingInArray(sFakturaAdressenAktiv,1)
		
		Dim sModulStatus 
		sModulStatus  = sFakturaAdressenAktiv
		
		'ShowMessage(sFakturaAdressenAktiv)
		if UCase(Mid(sModulStatus,1,3)) = UCase("tri") then
		
			On Error Resume Next
				sTrialDat = Right(sFakturaAdressenAktiv,10)
				If (Err.Number <> 0) Then
					Msgbox("Fehler beim Auslesen des Trial Datums" &vbLf  &"Der Vorgang wird ohne das Modul X-Address fortgefhrt.")
					sFakturaAdressenAktiv = "Nein"
			End If
			On Error GoTo 0
		End if
		
		if UCase(Mid(sFakturaAdressenAktiv,1,1)) = UCase("t") then
		  sFakturaAdressenAktiv = "Ja"
		End if
		
		
		'ShowMessage(sFakturaAdressenAktiv)
		
		If sFakturaAdressenAktiv = "Ja" Then 'Adressauswahl
		
		   'Auslesen der Parameter 
		   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlBelegEmpf')"
		   
		   sBelegAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
		
		   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlLieferEmpf')"
		   
		   sLieferAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
		  
		  Dim sFilterAdresse,sViewAdresse,sFieldAdresse, sErrorAdresse,oView,oRecordSet,bFilter,oCurrentRecord
		  
		  
		  'Auslesen Adresse 1: Belegadresse
		  If sBelegAdresseAktiv = "Ja" Then
		  
		  
		  
				sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Belegadresse"" = 1"
				sViewAdresse   ="FakturaAdressZuordnung"
				sFieldAdresse  ="AddressID"
				sErrorAdresse  ="Keine Belegadresse vorhanden. Der Beleg wird mit der Hauptadresse der Firma befllt."
				
				'sAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Belegadresse", sErrorAdresse)
				
				
				Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
				
				Set oRecordSet = oView.CreateRecordSet
				
				bFilter = oRecordSet.SetFilter(sFilterAdresse)
				
				If bFilter Then 'Filter OK
					If oRecordSet.Reccount > 1 Then
					  'Wenn Trial dann Medlung
					   if ((sLieferAdresseAktiv = "Ja") or  (sBelegAdresseAktiv = "Ja")) and (len(sTrialDat)>3)  then
					      ShowMEssage("Trial gltig bis zum: " &sTrialDat)
					   End if
				
		
					  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
					  
					  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  If oCurrentRecord Is Nothing Then  
					   sAdressID = "Null"
					  Else 
					    sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					  End If
					  
					    
					ElseIf oRecordSet.MoveFirst Then 
					  
					  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  
					   sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					
					Else 
					  sAdressID = "Null"
					  'showmessage(sErrorAdresse)
					End If
				
				Else 'Filter Ok
				  sAdressID = "Null"
				  'showmessage(sErrorAdresse)
				End If ' /Filter OK
				
				
		  Else sAdressID = "Null"
		  
		  End If
		  
		 'Auslesen Adresse 2: Lieferadresse
		 If sLieferAdresseAktiv = "Ja" Then
		 
				sViewAdresse   ="FakturaAdressZuordnung"
				sFieldAdresse  ="AddressID"
			    sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Lieferadresse"" = 1"
				sErrorAdresse  ="Keine Lieferadressen vorhanden. Der Beleg wird mit der Lieferadresse der Firma befllt, sofern vorhanden."
				
				'sLieferAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Lieferadresse", sErrorAdresse)
				Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
				
				Set oRecordSet = oView.CreateRecordSet
				
				bFilter = oRecordSet.SetFilter(sFilterAdresse)
				
				If bFilter Then 'Filter OK
					If oRecordSet.Reccount > 1 Then
					
					  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
					  
					  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  If oCurrentRecord Is Nothing Then  
					   sLieferAdressID = "Null"
					  Else 
					    sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					  End If
					  
					    
					ElseIf oRecordSet.MoveFirst Then 
					  
					  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  
					   sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					
					Else 
					  sLieferAdressID = "Null"
					  'showmessage(sErrorAdresse)
					End If
				
				Else 'Filter Ok
				  sLieferAdressID = "Null"
				  'showmessage(sErrorAdresse)
				End If ' /Filter OK
				
				
				
				
		  Else sLieferAdressID = "Null"
		
		  
		  End If 
		  
		  
		End If ' / Adressauswahl

' ----- 2. Ausfhren der Stored Procedure -----

Dim sProcedure, sTrennzeichen, sParameter
 
   sProcedure    = "Fs_Beleg_neu"
   sTrennzeichen = ";"
   sParameter    = sFirmenRecordid & ";" & sErfuser & ";" &  sPersonRecordid & ";" &  sBelegTypRecordid & ";" & sWaehrungID & ";" & sAdressID & ";" & sLieferAdressID

   'Stored Procedure kontrolliert ausfhren
    Dim bSP 

    bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
    
    If bSP = False Then
      'RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
      Wscript.Quit
    End If 
  

'---------------------------------------------------------------------------------------------------------------------
'/ Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------
  


' ----- 3. SQL Filter auf neuen Datensatz -----

'Filter auf den neu angelegten Datensatz


Dim sFilterBeleg

sFilterBeleg="select ""Factura_Belege"".""Recordid"" from ""Factura_Belege"" where (""Factura_Belege"".""Erf_Dat"" = (select max(""Factura_Belege"".""Erf_Dat"") from ""Factura_Belege"") and ""Factura_Belege"".""Erf_User"" = '" & sErfuser & "')"


ActivateOpenViewSetFilterDirectSQL "FakturaBelege",sFilterBeleg






Function SplitStingInArray(sString,i)

Dim sTrennzeichen, sStream, sArray, sText, iCounter, v0

sTrennzeichen = "|" 

sStream =sString

  
   If sStream <> "" Then ' Stream auflsen
   
     sArray = Split(sStream, sTrennzeichen)

	sText = ""

	For iCounter = 0 To UBound(sArray)
  		sText = sText & sArray(iCounter) & vbCr & vbLf  
	Next
    'On Error Funktion rein
    On Error Resume Next
	v0 = sArray(i) 
	If  (Err.Number <> 0) Then
		v0  = ""
	End If
	
    On Error GoTo 0
    
    SplitStingInArray = v0

  End if

End Function
