' Faktura-Software Scriptdatei 
' Funktion: 	Neuen Beleg zur Person anlegen Belegyp 6
' Ansicht:  	Kontakte
' Script:	Kontakte_07_BelegNeu_Typ_6.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->


'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "004"
'--------------------------------------------------------------------------------------------------------------
' Version 004
' - Erweiterung um Modul "FakturaAdressen"
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - Wenn AktiveAdr (Aktive Adresse) P ist, wird der Beleg fr eine Privatperson erstellt.
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Stored Procedure kontrolliert ausfhren (Sicherheitsmechanismen)
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - Prfung, ob Datensatz gesperrt
'--------------------------------------------------------------------------------------------------------------


Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "175"
sErrorSkript    = "007"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'----- Prfung, ob Datensatz gesperrt
Dim sGesperrt,sAktiveAdr,sFirmaGesperrt

sGesperrt = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Blocked")

sAktiveAdr = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ActiveAddress")


if ((sGesperrt="true") or (sGesperrt="wahr")) and sAktiveAdr = "P" then
  showmessage("Privatdatensatz fr Belege gesperrt. Es wird kein Beleg angelegt.")
  wscript.quit
end if


if sAktiveAdr="F" then
  sFirmaGesperrt = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("CompanyID.Firmen.ID.Blocked")
  
End if

if sFirmaGesperrt = "true" then
  showmessage("Firmendatensatz fr Belege gesperrt. Es wird kein Beleg angelegt.")
  Wscript.Quit
End if

'-----1. Auslesen der Basisinformationen : Firma, Person  -----

'Auslesen der Benutzerinformationen
Dim sErfuser
sErfuser = Crm.CurrentProject.CurrentUser

'Auslesen: Privatadresse oder Firmenadresse
Dim bPrivatadresse

bPrivatadresse = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ActiveAddress")




'Auslesen der FirmenRecordid
Dim   sFirmenRecordid

if bPrivatadresse = "P" then
   sFirmenRecordid = "00000000000000000000000000000000" 
Else
  sFirmenRecordid = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("CompanyID")
End If

'Abfrage zu Person
Dim sPersonRecordid
sPersonRecordid = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("ID")

If sPersonRecordid = "" Then
  RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Die Person konnte nicht bestimmt werden. " & vbLF & "Das Script wird nicht fortgesetzt")
  WScript.Quit
End If 



'----- 2. Auslesen des Belegtyps -----

'Auslesen des Belegtyps
Dim sBelegTypRecordid, sViewBelegTyp,sFieldBelegTyp,sFilterBelegTyp,sErrorBelegTyp

sViewBelegTyp   = "FakturaBeleg_Typen"
sFilterBelegTyp = """Factura_Beleg_Typen"".""ID"" = 6"
sFieldBelegTyp  = "Recordid"
sErrorBelegTyp  = "Der Belegtyp konnte nicht ermittelt werden"

sBelegTypRecordid = GetHiddenFieldContentByName(sViewBelegTyp, sFilterBelegTyp,sFieldBelegTyp, sErrorBelegTyp)

'Wenn Recordid leer dann Script beenden
If sBelegTypRecordid = "" Then
  Wscript.Quit
End If


'Auslesen der Belegwhrung
'Whrung auslesen
Dim sWaehrungID, sFilterWaehrung,sViewWaehrung,sFieldWaehrung, sErrorWaehrung


sFilterWaehrung = """Factura_Waehrungen"".""Standard"" = 1"

sViewWaehrung   ="FakturaWhrungen"
sFieldWaehrung  ="ID"
sErrorWaehrung  ="Whrung konnte nicht gefunden werden, Script wird beendet"

sWaehrungID = GetHiddenFieldContentByName(sViewWaehrung, sFilterWaehrung,sFieldWaehrung, sErrorWaehrung)



'---------------------------------------------------------------------------------------------------------------------
'Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------
Dim sAdressID, sLieferAdressID


'Auslesen, ob FakturaAdressen aktiv ist 
Dim sGlobalFilter,sFakturaAdressenAktiv

sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'FakturaAdressenAktiv')"
		
sFakturaAdressenAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")


If sFakturaAdressenAktiv = "Ja" Then 'Adressauswahl

   'Auslesen der Parameter 
   Dim sBelegAdresseAktiv, sLieferAdresseAktiv
   
   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlBelegEmpf')"
   
   sBelegAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")

   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlLieferEmpf')"
   
   sLieferAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
  
  Dim sFilterAdresse,sViewAdresse,sFieldAdresse, sErrorAdresse, oView,oCurrentRecord,oRecordSet,bFilter
  
  
  'Auslesen Adresse 1: Belegadresse
  If sBelegAdresseAktiv = "Ja" Then
        'Selektion Firmenadressen oder Privatadressen
        
        If bPrivatadresse = "F" Then
		  sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Belegadresse"" = 1 and ""Factura_Adressen_Zuordnung"".""ContactID"" = 0x" & sPersonRecordid 
		  sErrorAdresse  ="Keine Belegadresse vorhanden. Der Beleg wird mit der Hauptadresse der Firma befllt."
		
		Else
		  sFilterAdresse = """Factura_Adressen_Zuordnung"".""ContactID"" = 0x" & sPersonRecordid & " And ""Factura_Adressen_Zuordnung"".""Belegadresse"" = 1 And (""Factura_Adressen_Zuordnung"".""CompanyID"" is null or len(""Factura_Adressen_Zuordnung"".""CompanyID"") = 0)" 
		  sErrorAdresse  ="Keine Belegadresse vorhanden. Der Beleg wird mit der Hauptadresse der Person befllt."
		
		End If
				
		sViewAdresse   ="FakturaAdressZuordnung"
		sFieldAdresse  ="AddressID"
		
		'sAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Belegadresse", sErrorAdresse)
		
		Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
		
		Set oRecordSet = oView.CreateRecordSet
		
		bFilter = oRecordSet.SetFilter(sFilterAdresse)
		
		If bFilter Then 'Filter OK
			If oRecordSet.Reccount > 1 Then
			
			  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
			  
			  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			   If oCurrentRecord Is Nothing Then  
			   sAdressID = "Null"
			  Else 
			    sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			  End If
		
			   
			ElseIf oRecordSet.MoveFirst Then 
			  
			  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			   sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			
			Else 
			  sAdressID = "Null"
			  showmessage(sErrorAdresse)
			End If
		
		Else 'Filter Ok
		  sAdressID = "Null"
		  showmessage(sErrorAdresse)
		End If ' /Filter OK
		
  Else sAdressID = "Null"
  
  End If

 'Auslesen Adresse 2: Lieferadresse
 If sLieferAdresseAktiv = "Ja" Then
         
         If bPrivatadresse = "F" Then
		  sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Lieferadresse"" = 1 and ""Factura_Adressen_Zuordnung"".""ContactID"" = 0x" & sPersonRecordid
		  sErrorAdresse  ="Keine Lieferadressen vorhanden. Der Beleg wird mit der Lieferadresse der Firma befllt, sofern vorhanden."
		
		Else
		  sFilterAdresse = """Factura_Adressen_Zuordnung"".""ContactID"" = 0x" & sPersonRecordid & " And ""Factura_Adressen_Zuordnung"".""Lieferadresse"" = 1 And (""Factura_Adressen_Zuordnung"".""CompanyID"" is null or len(""Factura_Adressen_Zuordnung"".""CompanyID"") = 0)" 
		  sErrorAdresse  ="Keine Lieferadressen vorhanden. Der Beleg wird mit der Lieferadresse der Person befllt, sofern vorhanden."
		
		End If

		sViewAdresse   ="FakturaAdressZuordnung"
		sFieldAdresse  ="AddressID"
	   
		'sLieferAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Lieferadresse", sErrorAdresse)
		
		Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
		
		Set oRecordSet = oView.CreateRecordSet
		
		bFilter = oRecordSet.SetFilter(sFilterAdresse)
		
		If bFilter Then 'Filter OK
			If oRecordSet.Reccount > 1 Then
			  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Lieferadresse")
			  
			  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			  If oCurrentRecord Is Nothing Then  
			   sLieferAdressID = "Null"
			  Else 
			    sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			  End If
			   
			ElseIf oRecordSet.MoveFirst Then 
			  
			  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			   sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			
			Else 
			  sLieferAdressID = "Null"
			  showmessage(sErrorAdresse)
			End If
		
		Else 'Filter Ok
		  sLieferAdressID = "Null"
		  showmessage(sErrorAdresse)
		End If ' /Filter OK
		
  Else sLieferAdressID = "Null"
  
  End If 
End If ' / Adressauswahl


' ----- 2. Ausfhren der Stored Procedure -----

Dim sProcedure, sTrennzeichen, sParameter
 
   sProcedure    = "Fs_Beleg_neu"
   sTrennzeichen = ";"
   sParameter    = sFirmenRecordid & ";" & sErfuser & ";" &  sPersonRecordid & ";" &  sBelegTypRecordid & ";" & sWaehrungID & ";" & sAdressID & ";" & sLieferAdressID

   'Stored Procedure kontrolliert ausfhren
    Dim bSP 

    bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
    
    If bSP = False Then
      'RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
      Wscript.Quit
    End If 
  

'---------------------------------------------------------------------------------------------------------------------
'/ Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------
  
  
 

' ----- 3. SQL Filter auf neuen Datensatz -----

'Filter auf den neu angelegten Datensatz


Dim sFilterBeleg

sFilterBeleg="select ""Factura_Belege"".""Recordid"" from ""Factura_Belege"" where (""Factura_Belege"".""Erf_Dat"" = (select max(""Factura_Belege"".""Erf_Dat"") from ""Factura_Belege"") and ""Factura_Belege"".""Erf_User"" = '" & sErfuser & "')"


ActivateOpenViewSetFilterDirectSQL "FakturaBelege",sFilterBeleg







